import React, { Fragment, Component } from 'react';
import PageHeaderWrapper from '@/components/PageHeaderWrapper';
import Shell from '@/baseComponent/Shell';
import BlockTitle from '@/baseComponent/BlockTitle';
import ButtonDiy from '@/baseComponent/ButtonDiy';
import router from 'umi/router';
import FormArray from './component/FormArray';
import { getDetailInfo, handleAudit } from '@/pages/App/FormInsertDiy/AffairPage/publicApiService';
import { isJSON } from '@/baseComponent/utils';
import { Col, Row, Timeline, Icon, Tabs } from 'antd';
import ModalBatch from './ButtonListDom/ModalBatch';
import FlowImg from './component/FlowImg';
import { getHuanGeToken } from '@/utils/authority';
import config from '@/config/config';

const { TabPane } = Tabs;
/*
export default class Detail extends Component {
  /!**
   *    workId,dataBaseId,record,addFields
   * *!/
  constructor(props) {
    super(props);

    this.state = {
      detailInfo: {
        content: {},
        taskInfo: [],
      },
      show: false,
    };
  }

  componentDidMount() {
    const { state } = this.props.location;
    const { record } = state;
    getDetailInfo(record.id).then((x) => {
      if (x) {
        if (isJSON(x.content)) {
          x.content = JSON.parse(x.content);
        }
        if(typeof x.content === 'object' && x.content.defaultValues){
          for(let z in x.content.defaultValues){
            x.content = {
              ...x.content,
              ...x.content.defaultValues[z],
            }
          }        }
        this.setState({
          detailInfo: x,
          show: true,
        });
      }
    });
  }


  buttonDom = () => {
    const { detailInfo } = this.state;
    const { btns } = detailInfo;
    let res = [];
    if(typeof btns !== 'undefined' && Array.isArray(btns)){
      for(let z of btns){
      res.push(
          {
            type: z.name,
            name: z.name,
            component: 'ModalBatch',
            className:  z.name !== '通过' ? 'defaultRed' : 'defaultBlue',
            nameSpan: { big: 4, small: 5 },
            fileSpan: { big: 1, small: 1 },
            values: {
              [z.key]: z.value,
            },
            fields: [
              {
                key: 'reason',
                name: '审核意见',
                type: 'textarea',
              },
            ],
            beforeSubmit: (props, formValues) => {
              return {
                taskForm : {},
                examineMap: JSON.stringify(formValues),
              };
            },
            sourceKey: 'taskId',
            postKey: 'taskIds',
            apiServiceApi: handleAudit,
          }
        )
      }
      return res;
    }
    return [];
  };

  render() {
    const { state } = this.props.location;
    const { record, addFields, workId } = state;
    const { detailInfo, show } = this.state;
    const Btns = this.buttonDom();
    const dot1 = <Icon type={'check-circle'}
                       style={{ fontSize: '16px', color: 'rgb(82, 196, 26)' }}/>;
    const dot2 = <Icon type={'clock-circle-o'}
                       style={{ fontSize: '16px', color: 'red' }}/>;
    if(!show){
      return null;
    }
    return (<PageHeaderWrapper title="">
      <Shell>
        <div style={{ height: '54px', padding: '12px 0 12px 12px' }}>
          <ButtonDiy name="返回"
                     className="defaultBlue"
                     icon="arrow-left"
                     handleClick={() => {
                       router.goBack();
                     }}
          />
          {
            Btns.map((item)=>{
              return <ModalBatch key={item.type}
                                 {...item}
                                 handleSelectRows={()=>{console.log('清空')}}
                                 getPage={()=>{router.goBack()}}
                                 selectRows={[record]}/>
            })
          }
        </div>
      </Shell>
      <Shell>
        <BlockTitle
          isSmall={true}
          title={'申请信息'}
        />
        <Row>
          <Col span={20}>
            <FormArray config={addFields}
                       value={detailInfo.content}
                       changeValue={() => {
                         console.log(xxx);
                       }}
                       disabled={true}
                       readOnly={true}
                       fileSpan={{ big: 2, small: 2 }}
                       nameSpan={{ big: 6, small: 7 }}
            />
          </Col>
        </Row>
      </Shell>
      <Shell>

      <Tabs>
        <TabPane tab={'审批状态'} key={'1'}>
          <Row>
            <Col span={16} offset={2} style={{paddingTop: '30px', paddingBottom: '30px'}}>
              <Timeline>
                {
                  detailInfo.taskInfo.map((item) => {
                    let reason = item.respdesc;
                    if(item.taskVariable && item.taskVariable.reason){
                      reason = item.taskVariable.reason;
                    }
                    return (
                      <Timeline.Item dot={item.endTime ? dot1 : dot2}
                                     key={item.id}
                      >
                        {item.assignee ? <p><b>{item.assignee}</b></p> : <p>&nbsp; </p>}
                        <p>审批流程： {item.name}</p>
                        <p>审批状态： {item.status}</p>
                        <p>审批原因： {reason}</p>
                      </Timeline.Item>
                    );
                  })
                }
              </Timeline>
            </Col>
          </Row>
        </TabPane>
        <TabPane tab={'流程图'} key={'2'}>
            <FlowImg id={workId}/>
        </TabPane>
      </Tabs>
      </Shell>
    </PageHeaderWrapper>)
      ;
  }
}*/


export default class Detail extends Component{
  constructor(props){
    super(props);
    const { state } = this.props.location;
    let id = '';
    if(state && state.record && state.record.id){
      const { record } = state;
      id = record.id;
    }
    this.state={
      id,
    };
  }

  componentDidMount(){
    window.addEventListener('message', (event) => {
      if(event.data.indexOf('iframeDetailHeight') > -1){
        let height = Number(event.data.split('-')[1]);
        document.getElementById('detailIframeId').height = height;
      }
    }, false);
  }

  showAll = () => {
    this.setState({
      showAll: true,
    });
  };

  render(){
    const { id, showAll } = this.state;
    const url = config.onestopPC.split('/#/');
    let iframeUrl = `${url[0]}/#/IframeForDetail?id=${id}&token=${getHuanGeToken()}`;
 //   iframeUrl = `http://localhost:8000/onestop/IframeForDetail?id=${id}&token=${getHuanGeToken()}`;
    return (
      <PageHeaderWrapper title="">

        <Shell>
          <div style={{
            height: '54px',
            padding: '12px 0 12px 12px',
          }}>
            {
              showAll ?
                <ButtonDiy name="返回"
                           className="defaultBlue"
                           handleClick={()=>{
                             router.goBack();
                           }}
                           icon="arrow-left"
                />
                : null
            }
          </div>
        </Shell>
        <Shell>
        <iframe src={iframeUrl}
                frameBorder={0}
                id='detailIframeId'
                name='applyIframe'
                marginWidth="0"
                marginHeight="0"
                onLoad={this.showAll}
                allowTransparency="yes"
                seamless
                scrolling={'no'}
                style={{
                  width: '100%',
                  overflowY: 'hidden',
                  minHeight: '800px',
                }}
        />
        </Shell>
      </PageHeaderWrapper>
    )
  }
}
